/*
 * Proyecto: TestZip
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 12/05/2009
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oBrowseForFolderDlg1
   COMPONENT oFileSaveDlg1
   COMPONENT oFolder1
   COMPONENT oFolderPage1
   COMPONENT oFolderPage2
   COMPONENT oEdit1
   COMPONENT oLabel1
   COMPONENT oButton1
   COMPONENT oButton2
   COMPONENT oEdit2
   COMPONENT oLabel2
   COMPONENT oButton3
   COMPONENT oProgressBar1
   COMPONENT oLblFile
   COMPONENT oEdit3
   COMPONENT oLabel3
   COMPONENT oButton4
   COMPONENT oButton5
   COMPONENT oEdit4
   COMPONENT oLabel4
   COMPONENT oButton6
   COMPONENT oProgressBar2
   COMPONENT oLabel5
   COMPONENT oFileOpenDlg1
   COMPONENT oCheckbox1

   METHOD ChangeFileZip( oSender, cFile )
   METHOD ProgressZip( oSender, nBytes )
   METHOD ChangeFileUnZip( oSender, cFile )
   METHOD ProgressUnZip( oSender, nBytes )

   METHOD CreateForm()
   METHOD Button1Click( oSender )
   METHOD Button2Click( oSender )
   METHOD Button3Click( oSender )
   METHOD Button5Click( oSender )
   METHOD Button6Click( oSender )
   METHOD Button4Click( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD ChangeFileZip( oSender, cFile ) CLASS TForm1

   ::oLblFile:cText := cFile

   ProcessMessages()

RETURN NIL

//------------------------------------------------------------------------------

METHOD ProgressZip( oSender, nBytes ) CLASS TForm1

   ::oProgressBar1:nValue := nBytes

   ProcessMessages()

RETURN NIL

//------------------------------------------------------------------------------

METHOD ChangeFileUnZip( oSender, cFile ) CLASS TForm1

   ::oLabel5:cText := cFile

   ProcessMessages()

RETURN NIL

//------------------------------------------------------------------------------

METHOD ProgressUnZip( oSender, nBytes, nTotal ) CLASS TForm1

//   ::oProgressBar2:nMax := nTotal
   ::oProgressBar2:nValue := nBytes

   ProcessMessages()

RETURN NIL

//------------------------------------------------------------------------------

METHOD Button1Click( oSender ) CLASS TForm1

   WITH OBJECT ::oBrowseForFolderDlg1
      IF :Run()
         ::oEdit1:cText := :cRoot
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button2Click( oSender ) CLASS TForm1

   LOCAL cSrcFile, cTrgFile

   cSrcFile := ::oEdit1:cText + "\*.*"
   cTrgFile := ::oEdit2:cText

   WITH OBJECT TZipFile():Create()
      :aFileMask := { cSrcFile }
      :cFileName := cTrgFile
      //:cPassword := "test"
//Aadido Xevi
IF( !::oCheckbox1:lChecked )
   :cPathSave := ::oEdit1:cText
ENDIF
//Fin aadido Xevi
      :lRecurse  := .t.
      //:lIncludePath := .f.
      ::oProgressBar1:nValue := 0
      ::oProgressBar1:nMax := :FilesSize()
      ::oButton2:lEnabled := .F.
      :OnProgress := "ProgressZip"
      :OnChangeFile := "ChangeFileZip"
      IF :Run()
         Msginfo( "Zip file " + cTrgFile + " created correctly" )
      ELSE
         MsgAlert( "Zip file " + cTrgFile + " not created correctly" )
      ENDIF
      ::oButton2:lEnabled := .T.
   END WITH

   ::oProgressBar1:nValue := 0

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button3Click( oSender ) CLASS TForm1

   WITH OBJECT ::oFileSaveDlg1
      :cDefaultExt := "zip"
      IF :Run()
         ::oEdit2:cText := :cFilename
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button5Click( oSender ) CLASS TForm1

   LOCAL cZipFile, cTrgDir

   cZipFile := ::oEdit4:cText
   cTrgDir  := ::oEdit3:cText

   WITH OBJECT TUnZipFile():Create()
      :cFileName  := cZipFile
      :cDirectory := cTrgDir
      ::oProgressBar2:nValue := 0
      ::oProgressBar2:nMax := :FilesSize()
      ::oButton5:lEnabled := .F.
      :OnProgress := "ProgressUnZip"
      :OnChangeFile := "ChangeFileUnZip"
      IF :Run()
         Msginfo( "Zip file " + cZipFile + " unzipped correctly" )
      ELSE
         MsgAlert( "Zip file " + cZipFile + " not correctly unzipped" )
      ENDIF
      ::oButton5:lEnabled := .T.
   END WITH

   ::oProgressBar2:nValue := 0

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button6Click( oSender ) CLASS TForm1

   WITH OBJECT ::oFileOpenDlg1
      :cDefaultExt := "zip"
      IF :Run()
         ::oEdit4:cText := :cFilename
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button4Click( oSender ) CLASS TForm1

   WITH OBJECT ::oBrowseForFolderDlg1
      IF :Run()
         ::oEdit3:cText := :cRoot
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------
